function PGCalendar(url, opts) {
    var that = this;
    this.currentYear;
    this.currentMonth;
    this.events = [];
    this.bindMonths = [];
    this.opts = opts;
    this.detailContainer = $(opts.event_detail);
    this.calendarContainer = $(opts.calendar);
    this.hash = document.location.hash.replace('#', '');
    this.url =url;
    var today = new Date();
    $.ui.showMask();
   $.getJSON(url+"&y="+today.getFullYear()+"&m="+(parseInt(today.getMonth())+1),
    function(r) {
        that.bindMonths.push(today.getFullYear()+"-"+(parseInt(today.getMonth())+1));
        that.calendarContainer.html('<div class="cal-header"><a class="left prev"></a><span></span><a class="right next"></a></div><table ></table>')
        that.onJsonLoad(r, that);
        $.ui.hideMask();
    });
}

var PGCalendarUtil = {

    sortByDate: function(a, b) {
        var da = new Date(a.time),
        db = new Date(b.time);
        return da.valueOf() - db.valueOf();
    },

    parseDate: function(gDate) {
        var s = gDate.split(/-|T/)
        if (gDate.length < 12 || !s[4]) {
            var date = new Date(s[0], parseInt(s[1], 10) - 1, s[2]);
            return date;
        }
        else {
            var time = s[3].split(':'),
            hour = parseInt(time[0], 10),
            offset = s[4].split(':'),
            difHour = parseInt(offset[0], 10),
            day = parseInt(s[2], 10);
            var date = new Date(s[0], parseInt(s[1], 10) - 1, day, time[0], time[1]);
            return date;
        }
    },

    getLocalTimeZone: function() {
        return 'PDT';
        // return new Date().toString().replace(/^.*\(|\)$/g, "").replace(/[^A-Z]/g, "");
    },

    titleToID: function(str) {
        return str.replace(/[^\w\s]+/g, '').replace(/\s/g, '_').toLowerCase();
    },
    
    getMonthText: function(month) {
        switch (month) {
        case 1:
            text = '二月';
            break;
        case 2:
            text = '三月';
            break;
        case 3:
            text = '四月';
            break;
        case 4:
            text = '五月';
            break;
        case 5:
            text = '六月';
            break;
        case 6:
            text = '七月';
            break;
        case 7:
            text = '八月';
            break;
        case 8:
            text = '九月';
            break;
        case 9:
            text = '十月';
            break;
        case 10:
            text = '十一月';
            break;
        case 11:
            text = '十二月';
            break;

        default:
            text = '一月';
            break;
        }
        return text
    },

    getTimeText: function(time) {
        var hour = time.getHours();
        var pm = false;
        if (hour > 12) {
            hour -= 12;
            pm = true;
        } else if (hour == 12) {
            pm = true;
        }
        var min = time.getMinutes().toString();
        if (min.length == 1) min = '0' + min;
        return hour + ':' + min + (pm ? 'PM': 'AM');
    },

    getTimeTextBundle: function(start, end) {
        var start = PGCalendarUtil.getTimeText(start);
        var end = PGCalendarUtil.getTimeText(end);

        if (start == end) {
            return 'TBA';
        } else {
            return start + '~' + end + ' ' + PGCalendarUtil.getLocalTimeZone();
        }
    },
    
    getFormattedDateString: function( date ) {
        var month = date.getMonth() + 1;
        var monthStr = month < 10 ? '0' + month.toString() : month.toString();
        var dayStr = date.getDate() < 10 ? '0' + date.getDate().toString() : date.getDate().toString();
        return date.getFullYear() + '-' + monthStr + '-' + dayStr;
    }
}


PGCalendar.prototype.selectDate = function(date, that) {
    if (!that) that = this;
    var year = date.getFullYear();
    var month = date.getMonth();
    var day = date.getDate();
    $(that.opts.calendar + ' a.current_bg').removeClass('current_bg');
    $('a[data-date="' + (day < 10 ? '0' + day : day) +'"]').addClass('current_bg');
    var eventItem,
    startTime,
    endTime,
    description,
    location;
    var eventsToday = [];
    var htmlAr = [];
    var today = new Date();
    var isToday = today.getMonth() == month && today.getDate() == day && today.getFullYear() == year;
    for (k in this.events) {
        eventItem = this.events[k];
        if(eventItem.time){
            time = eventItem.time;
            if (time.getDate() == day && time.getFullYear() == year
            && time.getMonth() == month) {
                eventsToday = eventItem;
                break;
            }
        }
    }
    if (eventsToday.data && eventsToday.data.length > 0) {
        for (k in eventsToday.data) {
            htmlAr.push('<li onclick="activity.actionActivityInfo('+eventsToday.data[k].act_id+')"');
            if(eventsToday.data[k].isjoin == 1){
                htmlAr.push(' class="current"');
            }
            htmlAr.push('>'+eventsToday.data[k].act_name);
            if(eventsToday.data[k].isjoin == 1){
                htmlAr.push('<i></i>');
            }
            htmlAr.push('</li>');
        }

    } else {
        
        htmlAr.push('<p style="overflow:hidden;margin-top:30px;text-align:center">暂时没有活动哦！</p>');
    }
    that.detailContainer.html(htmlAr.join(''));
}

PGCalendar.prototype.renderCalendar = function(date, that) {
    if (!that) that = this;
    var cal = $('.calendar table')[0];
    var htmlAr = ['<tr><th><span class="first">周日</span></th><th><span>周一</span></th><th><span>周二</span></th><th><span>周三</span></th><th><span>周四</span></th><th><span>周五</span></th><th><span class="last">周六</span></th></tr>'];
    var item,
    selected,
    current,
    isToday,
    isEventDay,
    className,
    eventItem,
    hash;
    var year = date.getFullYear();
    var month = date.getMonth();
    var today = new Date();
    var counter = 0;
    var iscurrentMonth = month == today.getMonth() && year == today.getFullYear();
    that.currentYear = year;
    that.currentMonth = month;
    
    var lastDay = 28,
    weekOfDay = 0;
    for (var i = 28; i < 32; i++) {
        if (month == new Date(year, month, i).getMonth()) {
            lastDay = i;
        }
        else {
            break;
        }
    }
    weekOfDay = new Date(year, month, 1).getDay();
    var index = weekOfDay - 1;

    for (var i = 0; i < Math.ceil((lastDay + weekOfDay) / 7) * 7; i++) {
        if (counter == 0) htmlAr.push('<tr>')

        selected = isToday = isEventDay = false;
        className = '';
        var day = i - index;

        if (iscurrentMonth && day == today.getDate()) {
            isToday = true;
            className += ' today';
        }
        for (var j = 0; j < that.events.length; j++) {
            eventItem = that.events[j];
            time = eventItem.time;
            if (time.getDate() == day && time.getFullYear() == that.currentYear
            && time.getMonth() == that.currentMonth) {
                isEventDay = true;
                break;
            }
        }
        // hash = that.currentYear + '-' + (that.currentMonth + 1) + '-' + day;
        hash = PGCalendarUtil.getFormattedDateString( new Date(that.currentYear, that.currentMonth, day) );
        htmlAr.push('<td' + (className.length > 0 ? ' class="' + className + '"': '') + '>'
        + (i > index && day < lastDay + 1 ? '<a href="javascript:;"'
        + ' data-date="' + (day < 10 ? '0' + day : day) + '" >'
        + day + (isEventDay ? '<span class="event-day">●</span>': '')
        + '</a>': '<span class="empty"></span>') + '</td>');

        counter++;
        if (counter == 7) {
            counter = 0;
            htmlAr.push('</tr>')
        }
    }

    $(cal).html(htmlAr.join(''));
    var header = $(that.opts.calendar + ' .cal-header span')[0];
    var text = PGCalendarUtil.getMonthText(date.getMonth());
    header.innerHTML = year+'年 '+text;
    $(that.opts.calendar + ' table a').bind("click",function(){that.onCellClick(this, that)});
}

PGCalendar.prototype.onCellClick = function(r, that) {
    if (!that) that = this;
    var day = $(r).attr('data-date');
    that.selectDate(new Date(that.currentYear, that.currentMonth, day))
}

PGCalendar.prototype.nextMonth = function(that) {
    that.detailContainer.html('');
    if (!that) that = this;
    var month = that.currentMonth + 1;
    if (month > 11) {
        that.currentYear++;
        month = 0;
    }
    var strMonth = that.currentYear+"-"+(parseInt(month)+1);
    if(that.in_array(that.bindMonths,strMonth)){
        that.renderCalendar(new Date(that.currentYear, month, 1), that);
    }else{
        $.ui.showMask();
        $.getJSON(that.url+"&y="+that.currentYear+"&m="+(parseInt(month)+1),
                  function(json){
                      that.bindMonths.push(strMonth);
                      that.bindData(json,that);
                      that.renderCalendar(new Date(that.currentYear, month, 1), that);
                      $.ui.hideMask();
                  });
    }
}

PGCalendar.prototype.prevMonth = function(that) {
    that.detailContainer.html('');
    if (!that) that = this;
    var month = that.currentMonth - 1;
    if (month < 0) {
        that.currentYear--;
        month = 11;
    }
    var strMonth = that.currentYear+"-"+(parseInt(month)+1);
    if(that.in_array(that.bindMonths,strMonth)){
        that.renderCalendar(new Date(that.currentYear, month, 1), that);
    }else{
        $.ui.showMask();
        $.getJSON(that.url+"&y="+that.currentYear+"&m="+(parseInt(month)+1),
                  function(json) {
                      that.bindMonths.push(strMonth);
                      that.bindData(json,that);
                      that.renderCalendar(new Date(that.currentYear, month, 1), that);
                      $.ui.hideMask();
                  });
    }

}
PGCalendar.prototype.in_array = function(arr,val)
{
    for(k in arr){
        if(arr[k] == val){
            return true;
        }
    }
    return false;
}
PGCalendar.prototype.bindData = function(json,that){
    for (k in json.res) {
        if(json.res[k].length>0){
            var obj = {
                time: PGCalendarUtil.parseDate(k),
                data:json.res[k]
            }
            that.events.push(obj);
        }
    }
}
PGCalendar.prototype.onJsonLoad = function(json, that) {
   
    var today = new Date();
    var hash = that.hash;
    that.bindData(json,that);
   // that.upcomingEvent = that.generateUpcomingEventList(that.events, that);
    
    $('#calendar .prev').bind("click",function(r){that.prevMonth(that)});
    $('#calendar .next').bind("click",function(r){that.nextMonth(that)});
    $('.bl-calendar-stack').css({display:'block'});

        that.renderCalendar(today);
        that.selectDate(today, that);

}